package ankistream;

/** The <code>CardPanel</code> interface is implemented by a JPanel to work
  * with the AnkiBoxFrame to display a specific type of flash card.
  * <br>If you are creating a new type of flash card, you should create a new
  * JPanel subclass that implements this interface to display your card type.
  * <br> 
  * <br> Part of the Anki Stream project, a tool for long-term flash card
  * review.  Anki Stream is distributed under the MIT/X11 free software 
  * license, a copy of which should have come with this distribution.
  * @author Bishop Wilkins
  * @version 0.1
**/

public interface CardPanel {
	
	/** Called by the AnkiBoxFrame after this CardPanel is created,
	  * to give this CardPanel a reference to the Frame for box access.
	  * @param newAnkiBoxFrame this will be a reference to the main JFrame
	  *  itself.  Your CardPanel should henceforth call box manipulation 
	  *  methods through this.
	 */
	void setAnkiBoxFrame( AnkiStreamFrame newAnkiBoxFrame );
	
} // end interface CardPanel
