package ankistream;

import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.util.Vector;
import java.util.TreeSet;
import java.util.Collections;
import java.util.Random;
import java.util.NoSuchElementException;
import java.util.zip.DataFormatException;
import java.io.StringReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.FileNotFoundException;
import java.io.UnsupportedEncodingException;
import javax.swing.JOptionPane;
import net.n3.nanoxml.IXMLElement;
import net.n3.nanoxml.XMLElement;

/** Contains a mapping of meta card types as they appear in the xml data files 
  * to the corresponding meta card class names.
  * <br>If you are making a new type of flash card, you should add one line
  * to the getClassName method of this class that returns the class name of 
  * your new MetaCard given its card type name.
  * <br> 
  * <br> Part of the Anki Stream project, a tool for long-term flash card
  * review.  Anki Stream is distributed under the MIT/X11 free software 
  * license, a copy of which should have come with this distribution.
  * @author Bishop Wilkins
  * @version 0.1
*/ 
public class CardTypeIndex {
	
	/** Gets the name of the MetaCard subclass that corresponds to a specified
	  * flash card type as it appears in a Anki Box xml data file.
	  * <br>The anki box framework uses this method when loading MetaCards.
	  * @param cardTypeName the flash card type as it appears in the xml file.
	  * @return the name of the class corresponding to this card type.
	 */
	public static String getClassName( String cardTypeName ) {
		if ( cardTypeName.compareTo( "basic" ) == 0 ) 
			{ return "ankistream.BasicCard"; }
		if ( cardTypeName.compareTo( "heisig" ) == 0 ) 
			{ return "ankistream.HeisigCard"; }
		/* Add new card types here. */
		return null;
	}

} // end class CardTypeIndex
