package ankistream;
import java.io.File;
import java.util.Random;
import java.awt.Toolkit;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Dimension;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JFrame;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JLabel;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JTextField;
import javax.swing.JOptionPane; 
import javax.swing.JTextField;
import javax.swing.JCheckBox;
import javax.swing.JButton;
import javax.swing.JTextArea;
import javax.swing.JOptionPane;
import javax.swing.Timer;
import javax.swing.BorderFactory;
import javax.swing.JFileChooser;
import javax.swing.Timer;
import net.n3.nanoxml.IXMLElement;
import net.n3.nanoxml.XMLElement;

/** An "New Box" dialog for creating new boxes.
  * <br> 
  * <br> Part of the Anki Stream project, a tool for long-term flash card
  * review.  Anki Stream is distributed under the MIT/X11 free software 
  * license, a copy of which should have come with this distribution.
  * @author Bishop Wilkins
  * @version 0.1
*/ 
public class NewBoxDialog extends JDialog {

	// The preferences settings indicated on this form.
	JFrame owner;
	public String boxfilename;
	public String cardsetfilename;
	public boolean usercancelled;
	
	// Controls
	JTextField boxfilenamefield;
	JTextField cardsetfilenamefield;
	JButton browsebutton;
	JButton	okbutton;
	JButton cancelbutton;
	
	/** Creates and shows a new New Box dialog.
	 */
	public NewBoxDialog( JFrame newowner ) {
		
		// Set the owner.
		super( newowner );

		owner = newowner;

		boxfilename = "New Box.xml";
		cardsetfilename = "New Card Set.xml";
		usercancelled = true;

		// Layout the dialog.
		getContentPane().setLayout( new GridLayout(0,1) );
		JPanel p = new JPanel( new FlowLayout() );
		p.add( new JLabel( "Please specify file names to use to save the new"
							+ " box and card set." ));
		getContentPane().add( p );
		
		p = new JPanel( new FlowLayout() );
		p.add( new JLabel( "Box file: " ) );
		boxfilenamefield = new JTextField( boxfilename, 25 );
		p.add( boxfilenamefield );
		getContentPane().add( p );
		p = new JPanel( new FlowLayout() );
		p.add( new JLabel( 
			"(Warning: If the file exists already it will be overwritten.)" ) );
		getContentPane().add( p );

		p = new JPanel( new FlowLayout() );
		p.add( new JLabel( "Card Set file: " ) );
		cardsetfilenamefield = new JTextField( cardsetfilename, 22 );
		p.add( cardsetfilenamefield );
		browsebutton = new JButton( "Browse" );
		browsebutton.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ae ) { 
				JFileChooser fc = new JFileChooser( );
				fc.setCurrentDirectory( new File( "." ) );
				int returnVal = fc.showOpenDialog(owner);
					if(returnVal == JFileChooser.APPROVE_OPTION) {
					   cardsetfilenamefield.setText(
							fc.getSelectedFile( ).getName() );
					}
			}
		} );
		p.add( browsebutton );
		getContentPane().add( p );
		p = new JPanel( new FlowLayout() );
		p.add( new JLabel( 
"(If the card set exists already it will supply the new box's cards.)"));
		getContentPane().add( p );		
		
		p = new JPanel( new FlowLayout() );
		okbutton = new JButton( "OK" );
		okbutton.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ae ) { 
				boxfilename = boxfilenamefield.getText().trim();
				cardsetfilename = cardsetfilenamefield.getText().trim();
				
				if (boxfilename.length() > 0 && cardsetfilename.length() > 0) {
					usercancelled = false;
					dispose();
				} else {
					JOptionPane.showMessageDialog(	null, 
						"Please specify a different file name.", 
						"Invalid File Name", JOptionPane.ERROR_MESSAGE ); 					
				}
			}
		} );
		p.add( okbutton );
		cancelbutton = new JButton( "Cancel" );
		cancelbutton.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ae ) { 
				usercancelled = true;
				dispose();
			}
		} );
		p.add( cancelbutton );
		getContentPane().add( p );

		setTitle( "New Box" );
		pack();
		setLocationRelativeTo( owner );
		setModal( true );
		setVisible( true );
	}
}
