package ankistream;
import java.io.File;
import java.util.Random;
import java.awt.Toolkit;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Dimension;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JFrame;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JLabel;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JTextField;
import javax.swing.JOptionPane; 
import javax.swing.JTextField;
import javax.swing.JCheckBox;
import javax.swing.JButton;
import javax.swing.JTextArea;
import javax.swing.JOptionPane;
import javax.swing.Timer;
import javax.swing.BorderFactory;
import javax.swing.JFileChooser;
import javax.swing.Timer;
import net.n3.nanoxml.IXMLElement;
import net.n3.nanoxml.XMLElement;

/** An "Partition Sizes" dialog for specifying partition sizes.
  * <br> 
  * <br> Part of the Anki Stream project, a tool for long-term flash card
  * review.  Anki Stream is distributed under the MIT/X11 free software 
  * license, a copy of which should have come with this distribution.
  * @author Bishop Wilkins
  * @version 0.1
*/ 
public class PartitionSizesDialog extends JDialog {

	// The preferences settings indicated on this form.
	JFrame owner;
	public int[] sizes;
	public boolean usercancelled;
	
	// Controls
	JTextField sizesfield;
	JButton	okbutton;
	JButton cancelbutton;
	
	private String getsizesstring( int[] input ) {
		if ( input == null ) return "10, 35, 75, 180, 300, 560";
		String s = "";
		for ( int c = 0; c < input.length; c++ ) {
			s += input[c] + ", ";
		}
		s = s.substring(0, s.length()-2);
		return s;
	}
	
	private int[] getsizesarray( String input ) {
		String[] strs = input.split( "," );
		int[] i = new int[strs.length];
		for ( int c = 0; c < strs.length; c++ ) {
			try {
				i[c] = Integer.parseInt( strs[c].trim() );
			} catch ( NumberFormatException nfe ) {
				i = new int[] { 10, 35, 75, 180, 300, 560 };
				return i;
			}
		}
		return i;
	}
	
	/** Creates and shows the Partition sizes dialog with the given message.
	 */
	public PartitionSizesDialog( JFrame newowner, String message ) {
		
		// Set the owner.
		super( newowner );

		owner = newowner;
		
		sizes = new int[] { 10, 35, 75, 180, 300, 560 };
		
		getContentPane().setLayout( new BorderLayout() );
		JPanel lowerpanel = new JPanel( new GridLayout(0,1) );
		JTextArea ta = new JTextArea( message, 5, 24 );
		ta.setEditable( false );
		ta.setBackground( Color.LIGHT_GRAY );
		ta.setBorder( BorderFactory.createLineBorder( Color.BLACK ) );
		JPanel p = new JPanel( new FlowLayout() );
		p.add( ta );
		getContentPane().add( p, BorderLayout.CENTER );

		p = new JPanel( new FlowLayout() );
		p.add( new JLabel("Sizes: ") );
		sizesfield = new JTextField( getsizesstring( sizes ), 18 );
		p.add( sizesfield );
		lowerpanel.add( p );
		p = new JPanel( new FlowLayout() );
		okbutton = new JButton( "OK" );
		okbutton.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ae ) { 
				usercancelled = false;
				sizes = getsizesarray( sizesfield.getText() );
				dispose();
			}
		} );
		p.add( okbutton );
		cancelbutton = new JButton( "Cancel" );
		cancelbutton.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ae ) { 
				usercancelled = true;
				dispose();
			}
		} );
		p.add( cancelbutton );
		lowerpanel.add( p );
		getContentPane().add( lowerpanel, BorderLayout.SOUTH );

		setTitle( "Partition Sizes" );
		pack();
		setLocationRelativeTo( owner );
		setModal( true );
		setVisible( true );
	}
}
